<template>
    <div class="w-full">
        <section class="flex justify-center">
            <notebook-header :currentNotebook="currentNotebook"></notebook-header>
        </section>
        <section class="flex justify-center">
            <note-list @selected="handleNoteSelection" :notes="allNotes"></note-list>
        </section>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { State } from 'vuex-class'
import { Watch } from 'vue-property-decorator'
import { INotebook } from '@/store/types/notebooks'
import { INote } from '@/store/types/notebooks'
import NotebookHeader from '@/app/Editor/components/Notebook/NotebookHeader.vue'
import NoteList from '@/app/Editor/components/Notebook/NoteList.vue'
import { IRoot } from '@/store/types/root'

@Component({
    components: {
        NotebookHeader,
        NoteList,
    },
})
export default class NotebookNode extends Vue {
    // Lifecycle

    created() {
        if (!this.$store.state.Notebooks.notebooks) {
            this.$store.dispatch('init').catch(e => {
                throw new Error(e)
            })
        }
    }

    // Data

    // State

    @State((state: IRoot) => {
        if (!state.Notebooks) return state.Notebooks
        return state.Notebooks.currentNotebook
    })
    currentNotebook: INotebook | undefined

    @State((state: IRoot) => {
        if (!state.Notebooks) return state.Notebooks
        return state.Notebooks.notebooks
    })
    allNotebooks: INotebook[] | undefined

    // Computed

    get allNotes(): INote[] {
        if (!this.allNotebooks) return []

        if (this.allNotebooks.length < 1) return []

        if (!this.currentNotebook) return this.allNotesByDate

        const notes: INote[][] = this.allNotebooks
            .filter(
                notebook =>
                    this.currentNotebook &&
                    this.currentNotebook.name === notebook.name &&
                    notebook.notes
            )
            .map(notebook => notebook.notes as INote[])

        return notes
            .flat()
            .sort((a, b) => b.createdOn.getTime() - a.createdOn.getTime())
    }

    get allNotesByDate(): INote[] {
        if (!this.allNotebooks) return []

        const notes: INote[][] = this.allNotebooks
            .filter(notebook => notebook.notes)
            .map(notebook => {
                return notebook.notes as INote[]
            })

        const sortedNotes: INote[] = notes
            .flat()
            .sort((a, b) => b.createdOn.getTime() - a.createdOn.getTime())

        return sortedNotes
    }

    // Watchers

    @Watch('currentNotebook', { immediate: true })
    watchCurrentNotebook() {
        if (this.currentNotebook) {
            const newRoute = `/notebook/${this.currentNotebook.id}/`
            if (this.$route.fullPath !== newRoute) this.$router.push(newRoute)
        }
    }

    // Methods

    handleNoteSelection(note: INote) {
        if (note.id) {
            const url = `/notebook/${note.notebook.id}/${note.id}/`
            if (this.$route.fullPath !== url) this.$router.push(url)
        }
    }
}
</script>